package com.example.tipcalc_radio

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.widget.*

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        // connect variables to interface Views
        val etBillAmount = findViewById<EditText>(R.id.etBillAmount)
        val rgTip = findViewById<RadioGroup>(R.id.rgTip)
        val tvTipAmount = findViewById<TextView>(R.id.tvTipAmount)
        val tvTotalAmount = findViewById<TextView>(R.id.tvTotalAmount)
        val btnCalc = findViewById<Button>(R.id.btnCalc)

        // variables for calculation
        var bill: Double
        var tip: Double
        var total: Double
        var tip_index: Int  //used to identify the checked radio button

        // when the user clicks the Calculate button
        btnCalc.setOnClickListener{
            try {
                bill = etBillAmount.text.toString().toDouble()  //casting might fail if left empty try-catch

                tip_index = rgTip.checkedRadioButtonId  //determine index of selected radiobutton
                if(tip_index != -1) {
                    val userRadioButton = findViewById<RadioButton>(tip_index)
                    tip = userRadioButton.tag.toString().toDouble()
                    total = bill*(1+tip);
                    //Toast.makeText(this,total.toString(),Toast.LENGTH_SHORT).show()
                    tvTipAmount.text = String.format("Tip Amount: \t\t$%.2f",tip*bill)
                    tvTotalAmount.text = String.format("Total Amount: \t$%.2f",total)
                }
                else{
                    //an index of -1 means that no radio button was selected from the group
                    Toast.makeText(this,"Please select a tip amount",Toast.LENGTH_LONG).show()
                }

            }catch(e: Exception){
                Toast.makeText(this,"Please enter number for bill amount",Toast.LENGTH_LONG).show()
            } // end try-catch

        }// end button-click listener --> onClick method implied

        // when the user changes the bill amount, clear out result
        etBillAmount.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable) {}

            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {}

            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
                tvTipAmount.text = "Tip Amount: ----------"
                tvTotalAmount.text = "Total Amount: ----------"
            }
        })

        // when the user changes the checked radio button, clear out result
        rgTip.setOnCheckedChangeListener { rg, checked_index ->
            val userRadioButton = findViewById<RadioButton>(checked_index)
            Toast.makeText(this, "CHECKED "+userRadioButton.text, Toast.LENGTH_SHORT).show()
            tvTipAmount.text = "Tip Amount: ----------"
            tvTotalAmount.text = "Total Amount: ----------"
        }

    }//end onCreate
}//end MainActivity class
